// Transforms merge information into partition
// Format ./transform merge_information output_filename
//
#include<iostream>
#include<vector>
#include<string>
#include<fstream>

using namespace std;

class community{
public:
  int read_in(string filename);
  int print_colors(string outputfilename);

private: 
  vector<vector<unsigned int> > communities;

};

int community::print_colors(string outputfilename){
  unsigned int counter=0;
  const unsigned int sizer=communities.size();
  vector<unsigned int> colors(sizer,0);
  for (unsigned int icomm=0;icomm<sizer;icomm++){
    const unsigned int sizer2=communities[icomm].size();
    for (unsigned int inode=0;inode<sizer2;inode++){
      colors[communities[icomm][inode]]=counter; 
    }
    if (sizer2>0){
	    counter++;
    }
  }

   cout << " Will output into " << outputfilename << endl;

  ofstream file(outputfilename.c_str());
  if (!file){
     cerr << " Something went wrong with the output. Will exit " << endl;
     exit(0);
  }

  const unsigned int sizer3=colors.size();
  for (unsigned int inode=0;inode<sizer3;inode++){
    file << inode << "\t" << colors[inode] << "\t1" << endl;

  }
  cout << "Number of colors " << counter << endl;
}


int community::read_in(string filename){
  fstream file(filename.c_str());
  if (! file){
	cerr << "File " << filename << " could not be opened. Will exit!" << endl;
	exit(0);
  };

  // Determine number of nodes
  unsigned int start=0;
  unsigned int ende=0;
  unsigned int number_nodes=0;
  while (!file.eof()){
	file >> start >> ende;
	if (start>number_nodes){
		number_nodes=start;
	}
	if (ende>number_nodes){
		number_nodes=ende;
	};
  }

  communities.clear();
  for (unsigned int inode=0;inode < number_nodes+1;inode++){
	vector<unsigned int> to_insert;
	to_insert.push_back(inode);
	communities.push_back(to_insert);
  }

  file.close();
  file.open(filename.c_str());
  
  while (!(file.eof())){
    file >> start >> ende;
    if (communities[ende].size()!=0){
	const unsigned int sizer=communities[ende].size();
	for (unsigned int iende=0;iende<sizer;iende++){
		communities[start].push_back(communities[ende][iende]);
	}
	communities[ende].clear();
    };
  }

};




int main(int argc,char* argv[]){
  string filename(argv[1]);
  string outputfilename(argv[2]);
  community com;
  com.read_in(filename);
  com.print_colors(outputfilename);

  return 0;
}
